﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.86
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI

	Private CustomListView1 As CustomListView
	Private PCLV As PreoptimizedCLV
	Type MyImageData (IndexOfFirstImage As Int)
	Private MediaManager As SimpleMediaManager
	
	Dim FirstLineData, SecondLineData As List
	Dim ChannelName As List
	Dim IconLink As List
	Dim StreamResolution As List
	
End Sub

'You can add more parameters here.
Public Sub Initialize
	FirstLineData.Initialize
	SecondLineData.Initialize
	ChannelName.Initialize
	IconLink.Initialize
	StreamResolution.Initialize
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	'load the layout to Root
	Root.LoadLayout("MediaSelectionBy4")
	
	MediaManager.Initialize
	PCLV.Initialize(Me, "PCLV", CustomListView1)
	
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.
Sub B4XPage_Appear
	
End Sub
Sub B4XPage_Resize (Width As Int, Height As Int)

End Sub
Sub B4XPage_MenuClick (Tag As String)

End Sub

Sub GetM3uLink(url As String)
	Dim job As HttpJob
	job.Initialize("Job", Me)
	job.Tag = "Download Arabic"


	Dim poststr As String = url
	Log(poststr)
	
	job.Download(poststr)
	
	job.GetRequest.Setheader("Accept", "application/json")
	job.GetRequest.SetContentEncoding("text/plain")
	
End Sub

Sub JobDone (Job As HttpJob)
	Log("JobName = " & Job.JobName & ", Success = " & Job.Success)
	Log("JobTag = " & Job.Tag)
	
	Try
		If (Job.Success = True) Then
			'Get Data from file
			Dim FileData As String = Job.GetString
			
			'Split Data
			Dim strData() As String
			strData = Regex.Split("#EXTINF:", FileData)
						
			'#EXTINF: contains 2 or 3 line feed with Info and URL
			FirstLineData.Clear
			SecondLineData.Clear
			ChannelName.Clear
			IconLink.Clear
			
			'Log(strData.Length - 1)
			
			For g88 = 0 To strData.Length - 1
				If strData(g88) = "" Then
					'dont add empty field
				Else If strData(g88).Contains("#EXTM3U") Then
					'dont add the #EXTM3U which is always in first line of the file
				Else
				
					'Parse the list that contains 2 or 3 line of data
					'1st = Info and Channel Name
					'2nd = URL of stream (2 line) or Referral Url (3 line)
					'3rd = URL of stream
					Dim GetData As String
					GetData = strData(g88)
					
					'How many line feed
					Dim strDataCRLF() As String
					strDataCRLF = Regex.Split(CRLF, GetData)
					
					'Seen EXTVLCOPT = 3 line feed Else 2 line feed
					ParseLineData(GetData, strDataCRLF.Length)
										
				End If
			Next
			
		Else
						
			'Display Error
			ToastMessageShow("Error: " & Job.ErrorMessage, True)
					
		End If
	Catch
		Log("Error in JobDone")
	End Try
	
	Job.Release
	
	If ChannelName.Size >= 1 Then
		Dim height As Int = 150dip

		For i = 1 To ChannelName.Size Step 4
			PCLV.AddItem(height, xui.Color_White, CreateMyImageData(i))
		Next
		
		PCLV.ShowScrollBar = True 'no fast scrolling
		PCLV.ExtraItems = 3
		PCLV.Commit
	Else
		ToastMessageShow("Error loading channels: < 1", True)
	End If
End Sub

Sub ParseLineData(GetData As String, xLength As Int)
	Dim WhatIndex, WhatIndex2, WhatIndex3 As Int
	WhatIndex = GetData.IndexOf(CRLF)	'First CRLF
	WhatIndex2 = GetData.IndexOf(",")	'First COMMA
	WhatIndex3 = GetData.IndexOf2(CRLF, WhatIndex + 1) 'Second CRLF
			
	If WhatIndex <> - 1 Then
		'Get firstline up to comma contains other INFO
		'Get secondline contains URL of stream (if line 2)
		'Get thirdline contains URL of stream (if line 3)
		Dim FLData, SLData, TLData As String
		If xLength = 2 Then
			'2 line feed
			FLData = GetData.SubString2(0, WhatIndex2).Replace(CRLF, "")
			SLData = GetData.SubString(WhatIndex + 1).Replace(CRLF, "")
		Else
			'3 line feed
			FLData = GetData.SubString2(0, WhatIndex2).Replace(CRLF, "")
			SLData = GetData.SubString(WhatIndex3 + 1).Replace(CRLF, "")
			TLData = GetData.SubString2(WhatIndex + 1, WhatIndex3).Replace(CRLF, "") 'not used
		End If

		FirstLineData.Add(FLData)
		SecondLineData.Add(SLData)
			
		'--------------------------------------------------------------------------------
			
		'Get Channel name after comma to end of line and contains resolution info
		'Get Resolution
		If WhatIndex <> -1 Then
			Dim WhatChannelName As String
			WhatChannelName = GetData.SubString2(WhatIndex2 + 1, WhatIndex).Replace(CRLF, "")
			
			'Index of resolution text (seen most inside () )
			Dim WhatCIndex As Int
			WhatCIndex = WhatChannelName.IndexOf("(")
			
			If WhatCIndex <> - 1 Then				
				'Add Channel Name (without eg..(1080) )
				Dim cChannel As String
				cChannel = WhatChannelName.SubString2(0, WhatCIndex)
				ChannelName.Add(cChannel)
				
				'Add resolution info
				StreamResolution.Add(cChannel.SubString(WhatCIndex))
			Else
				'No resolution info with channel name
				ChannelName.Add(WhatChannelName)
				
				'No Resolution info available
				StreamResolution.Add("Not Available")
			End If
			
		Else
			'Error....No , detected in .m3u file
			ChannelName.Add("Not Available")
			StreamResolution.Add("Not Available")
		End If
	
		'--------------------------------------------------------------------------------
	
		'Get Icon Link, Group Title and ID in First Line Data
		Dim GetFirstLineData() As String
		GetFirstLineData = Regex.Split(" ", FLData)
		
		For x3 = 0 To GetFirstLineData.Length - 1
			Dim DataGet As String = GetFirstLineData(x3)
			
			If DataGet.Contains("tvg-logo") Then
				Dim WhatIndexFirstQuote As Int
				WhatIndexFirstQuote = DataGet.IndexOf(QUOTE)
				
				If WhatIndexFirstQuote <> - 1 Then
					Dim ParseData As String
					ParseData = DataGet.SubString(WhatIndexFirstQuote + 1)
					ParseData = ParseData.Replace(QUOTE, "")
					IconLink.Add(ParseData)
				End If
			End If
		Next
		
		'Add NA if none available
		If ChannelName.Size <> IconLink.Size Then
			IconLink.Add("Not Available")
		End If
		
	Else
		'Error...No CRLF detected in .m3u file
		FirstLineData.Add("Error")
		SecondLineData.Add("Error")
		ChannelName.Add("Error")
		IconLink.Add("Error")
	End If
End Sub

Sub CustomListView1_VisibleRangeChanged (FirstIndex As Int, LastIndex As Int)
	For Each i As Int In PCLV.VisibleRangeChanged(FirstIndex, LastIndex)
		Dim item As CLVItem = CustomListView1.GetRawListItem(i)
		Dim pnl As B4XView = xui.CreatePanel("")
		'item.Panel.AddView(pnl, 0, 0, item.Panel.Width, item.Panel.Height)
		item.Panel.AddView(pnl, 0, 0, 100%x, item.Panel.Height)
		
		Dim data As MyImageData = item.Value
		
		'Create the item layout
		pnl.LoadLayout("item")
		
		For x = 0 To 3
			
			If (data.IndexOfFirstImage + x) <= IconLink.Size Then
				Dim WhatListIndex As Int
				WhatListIndex = (data.IndexOfFirstImage + x) - 1
				
				Dim GetChannelName As String
				GetChannelName = ChannelName.Get(WhatListIndex)
				
				pnl.GetView(x).GetView(1).Text = (data.IndexOfFirstImage + x) & " " & GetChannelName
				pnl.GetView(x).GetView(1).Tag = (data.IndexOfFirstImage + x)

				Dim GetIconLink As String
				GetIconLink = IconLink.Get(WhatListIndex)
				'Log(GetIconLink)
				MediaManager.SetMedia(pnl.GetView(x).GetView(0), GetIconLink)
			End If
		Next
	Next
	
	'The purpose of this call is to find panels that are no longer in the views tree and cancel any ongoing request that is no longer relevant.
	'It also happens automatically from time to time but in this case, as many requests are sent frequently, it is better to force it to trim the cache.
	'Note that you need to add HU2_PUBLIC to the build configuration.
	MediaManager.TrimMediaCache
End Sub
Sub panelText_Click
	Dim panel As B4XView = Sender
	Dim label As B4XView = panel.GetView(1)
	Dim WhatIndex As Int = label.tag
	Log(WhatIndex)
	
	If WhatIndex <= SecondLineData.Size Then
		Dim GetUrl As String
		GetUrl = SecondLineData.Get(WhatIndex)
		B4XPages.ShowPage("Media Player")
		B4XPages.MainPage.Page3.GetStreamFile(GetUrl)
	Else
		Log("Error showing video and getting link")
	End If
End Sub

Public Sub CreateMyImageData (IndexOfFirstImage As Int) As MyImageData
	Dim t1 As MyImageData
	t1.Initialize
	t1.IndexOfFirstImage = IndexOfFirstImage
	Return t1
End Sub

Sub RefreshMedia(url As String)
	CustomListView1.Clear
	GetM3uLink(url)
End Sub


